<template>
  <prime-multi-select
    :model-value="modelValue"
    :options="groups"
    option-label="name"
    :filter="true"
    class="multiselect-custom"
    @change="$emit('update:modelValue', $event.value)"
  >
    <template #option="slotProps">
      <keyword-group-chip :keyword-group="slotProps.option" />
    </template>
    <template #value="{value}">
      <template v-if="!value || value.length === 0">
        Выберите группы
      </template>
      <div v-else class="group-item-container">
        <div
          v-for="option of value"
          :key="option.id"
          class="group-item-container__value"
          :style="{ backgroundColor: option.color, color: getKeywordGroupColor(option) }"
        >
          <span>{{ option.name }}</span>
        </div>
      </div>
    </template>
  </prime-multi-select>
</template>

<script lang="ts">
import PrimeMultiSelect from 'primevue/multiselect/MultiSelect.vue';
import { defineComponent, PropType } from 'vue';
import { getKeywordGroupColor } from '@/api/keywordGroups';
import KeywordGroupChip from '@/components/KeywordGroupChip.vue';
import { KeywordGroup } from '@/models/keywordGroup';

export default defineComponent({
  name: 'keyword-group-multi-select',
  components: {
    PrimeMultiSelect,
    KeywordGroupChip,
  },
  props: {
    modelValue: { type: Array as PropType<KeywordGroup[]>, default: null },
    groups: { type: Array as PropType<KeywordGroup[]>, required: true },
  },
  emits: ['update:modelValue'],
  methods: {
    getKeywordGroupColor(group: KeywordGroup) {
      return getKeywordGroupColor(group);
    },
  },
});
</script>
<style lang="scss" scoped>
.group-item-container {
    display: inline-flex;

    &__value {
        margin-right: .5rem;
        padding: 0 .5rem;
        border-radius: 3px;

        & > :not(:last-child) {
            margin-right: 10px;
        }
    }
}
</style>
